#ifndef EFL_UI_FOCUS_MANAGER_SUB_EO_HH
#define EFL_UI_FOCUS_MANAGER_SUB_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "efl_ui_focus_manager.eo.h"
#include "efl_ui_focus_manager_sub.eo.h"
#include "efl_ui_focus_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#include "efl_ui_focus_manager.eo.hh"
#include "efl_ui_focus_object.eo.hh"
namespace efl { namespace ui { namespace focus { namespace manager { 
struct Sub;
} } } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::focus::manager::Sub> : ::std::true_type {}; } }
namespace efl { namespace ui { namespace focus { namespace manager { 
struct Sub;
} } } } 
namespace efl { namespace ui { namespace focus { 
struct Manager;
} } } 
namespace efl { 
struct Object;
} 
namespace efl { namespace ui { namespace focus { 
struct Object;
} } } 

namespace eo_cxx {
namespace efl { namespace ui { namespace focus { namespace manager { 
struct Sub {
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_FOCUS_MANAGER_SUB_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::focus::manager::Sub() const;
   operator ::efl::ui::focus::manager::Sub&();
   operator ::efl::ui::focus::manager::Sub const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Sub,  ::efl::Object,  ::efl::ui::focus::Manager> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Sub const ,  ::efl::Object const ,  ::efl::ui::focus::Manager const > operator&() const { return {this}; }
   /// @endcond
};
} } } } 
}
namespace efl { namespace ui { namespace focus { namespace manager { 
struct Sub : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl ::ui ::focus::Manager)
{
   explicit Sub( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Sub(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Sub(Sub const& other) = default;
   Sub(Sub&& other) = default;
   Sub& operator=(Sub const& other) = default;
   Sub& operator=(Sub&& other) = default;
   Sub()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Sub( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Sub(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_FOCUS_MANAGER_SUB_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Sub,  ::efl::Object,  ::efl::ui::focus::Manager> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Sub const ,  ::efl::Object const ,  ::efl::ui::focus::Manager const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Sub) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Sub>::value, "");
} } } } 
#endif
